; UpWinMon - top-level windows monitor
; http://www.geocities.com/xmemor/2lz/upwinmon_asm.zip
; http://www.geocities.com/xmemor/2lz/tinyasm.html

.386
.model	flat,stdcall
option	casemap:none

include			\masm32\include\windows.inc
include			\masm32\include\user32.inc
include			\masm32\include\kernel32.inc
include			\masm32\include\shell32.inc
include			\masm32\include\shlwapi.inc
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\shell32.lib
includelib	\masm32\lib\shlwapi.lib

;EnChProc		proto :DWORD,:DWORD,:DWORD
;EnWinProc	proto :DWORD,:DWORD

.data

filename		db "UpWinMon.txt",0
about				db "by kero <geocities.com/xmemor>, 2006-06-12 (init: 2004-05-13)",0

caption			db "SET MONOSPACED FONT: Courier, FixedSys,..",13,10,13,10
						db "Z-ord zTp  hWnd     Status  Width  Height    Left    Top   ThreadID   ProcessID  Exec.file%s%d%sText%s%d%sClass",13,10,13,10,0

format			db "%4lu   %d   %8.8lx   %s  %6d  %6d  %6d %6d   %8.8lx   %8.8lx   ",0
format0			db "%s%s-%d%s   %s-%d%s   %s%s",13,10,0
p_					db "%",0
s_					db "s",0

.data?

hMon				dd ?
hMon_a			dd ?
processid		dd ?
threadid		dd ?
hSnapshot		dd ?
pe32				PROCESSENTRY32 <?>
rt					RECT <?>
lft					dd ?
tp					dd ?
wdth				dd ?
hght				dd ?
count				dd ?
fnamelen		dd ?
fnamelen2		dd ?
namelen			dd ?
namelen2		dd ?
status			dd ?
keystate		dd ?
bigbuf			db 65535 dup(?)
bigbuf2			db 65535 dup(?)
buf					db 1024 dup(?)
frmt				db 512 dup(?)
winclass		db MAX_PATH+1 dup(?)
winname			db MAX_PATH+1 dup(?)
windowfile	db MAX_PATH+1 dup(?)

ztp					dd ?

.code

;###########################################################################################

EnChProc proc hwnd:HWND,param:DWORD
		invoke	SendMessage,hwnd,WM_GETTEXT,MAX_PATH,addr winname
		invoke	lstrcmp,addr winname,addr filename
		test	eax,eax
		jz	@f
		ret
@@:
		mov	eax,hwnd
		mov	hMon,eax
		xor	eax,eax
	 	ret
EnChProc endp

;###########################################################################################

EnWinProc proc hwnd:HWND,param:DWORD
		invoke	IsWindowVisible,hwnd
		.if	eax==0
			mov	byte ptr status,'H'
			.if	keystate!=0
				jmp	_end
			.endif
		.else
			mov	byte ptr status,'V'
		.endif
		invoke	IsWindowEnabled,hwnd
		.if	eax==0
			mov	 byte ptr status+1,'D'
		.else
			mov	byte ptr status+1,'E'
		.endif
		invoke	IsIconic,hwnd
		.if	eax!=0
			mov	byte ptr status+2,'m'
		.else
			invoke	IsZoomed,hwnd
			.if	eax!=0
				mov	byte ptr status+2,'M'
			.else
				mov	byte ptr status+2,' '
			.endif
		.endif
		invoke	GetWindowRect,hwnd,addr rt

		mov	eax,rt.left
		mov	lft,eax
		mov	eax,rt.top
		mov	tp,eax
		mov	eax,rt.right
		mov	wdth,eax
		mov	eax,rt.bottom
		mov	hght,eax

		mov	eax,lft
		sub	wdth,eax		
		mov	eax,tp
		sub	hght,eax
		invoke	GetWindowThreadProcessId,hwnd,addr processid
		mov	threadid,eax
		invoke	CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,processid
		mov	hSnapshot,eax
		mov	pe32.dwSize,sizeof pe32 
		invoke	Process32First,hSnapshot,addr pe32 
@@:
		cmp	eax,FALSE
		jz	_false
		mov	eax,processid
		cmp	pe32.th32ProcessID,eax
		jz	@f
		invoke	 Process32Next,hSnapshot,addr pe32 
		jmp	@b
@@:
		invoke	lstrcpy,addr windowfile,addr pe32.szExeFile
		invoke	PathStripPath,addr windowfile
		invoke	CharLower,addr windowfile
		invoke	lstrlen,addr windowfile
		.if	eax > fnamelen2
			mov	fnamelen2,eax
		.endif
		jmp	@f
_false:
		mov	byte ptr windowfile,'?'
		mov	byte ptr windowfile+1,0
@@:
		invoke	CloseHandle,hSnapshot
		invoke	GetClassName,hwnd,addr winclass,MAX_PATH
		invoke	SendMessage,hwnd,WM_GETTEXT,MAX_PATH,addr winname
		invoke	lstrlen,addr winname
		.if	eax > namelen2
			mov	namelen2,eax
		.endif
		inc	count

		invoke GetWindowLong,hwnd,GWL_EXSTYLE
		and eax,WS_EX_TOPMOST
		shr eax,3
		mov ztp,eax

		invoke	wsprintf,addr buf,addr frmt,count,ztp,hwnd,addr status,wdth,hght,\
				lft,tp,threadid,processid,addr windowfile,addr winname,addr winclass
		invoke	lstrcat,addr bigbuf,addr buf
_end:
		mov	eax,1
	 	ret
EnWinProc endp

;###########################################################################################

start:
		invoke	GetAsyncKeyState,VK_CONTROL 	; Ctrl key
		and	eax,0ffff8000h
		mov	keystate,eax
		xor	eax,eax
		mov	hMon,eax
		mov	status,eax

		invoke	lstrlen,addr filename
		mov	fnamelen,eax

		invoke	 CreateFile,addr filename,GENERIC_READ or GENERIC_WRITE,\
				FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
		cmp	eax,INVALID_HANDLE_VALUE
		jz	_exit
		mov	count,eax

		invoke	WriteFile,eax,addr filename,fnamelen,addr fnamelen,0
		mov	tp,eax
		invoke	CloseHandle,count
		cmp	tp,0
		jz	_exit

		invoke	ShellExecute,0,0,addr filename,0,0,SW_SHOWNORMAL	;SW_SHOWMAXIMIZED
		cmp	eax,33
		jb	_exit
@@:
		invoke	GetDesktopWindow
		invoke	EnumChildWindows,eax,addr EnChProc,0
		cmp	hMon,0
		jz	@b

		invoke GetAncestor,hMon,GA_ROOT
		mov hMon_a,eax
		invoke GetWindowLong,hMon_a,GWL_STYLE
		and eax,not WS_MINIMIZEBOX
		invoke SetWindowLong,hMon_a,GWL_STYLE,eax
		invoke SetWindowPos,hMon_a,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE OR SWP_NOMOVE OR SWP_NOACTIVATE OR SWP_FRAMECHANGED

		xor	eax,eax
		mov	dword ptr bigbuf2,eax
		mov	namelen,eax
		mov	fnamelen,eax
@@:
		invoke Sleep,100
		xor	eax,eax
		mov	namelen2,eax
		mov	fnamelen2,eax
		mov	count,eax

		invoke wsprintf,addr frmt,addr format0,addr format,addr p_,fnamelen,addr s_,addr p_,namelen,addr s_,addr p_,addr s_
		sub fnamelen,6
		sub namelen,1
		invoke wsprintf,addr buf,addr caption,addr p_,fnamelen,addr s_,addr p_,namelen,addr s_
		invoke wsprintf,addr bigbuf,addr buf,0,0

		invoke	 EnumWindows,addr EnWinProc,0
		mov	eax,namelen2
		mov	namelen,eax
		mov	eax,fnamelen2
		mov	fnamelen,eax
		invoke	IsWindow,hMon
		test	eax,eax
		jz	@f
		invoke	 lstrcmp,addr bigbuf2,addr bigbuf
		test	eax,eax
		jz	@b
		invoke	lstrcpy,addr bigbuf2,addr bigbuf
		invoke	SendMessage,hMon,WM_SETTEXT,0,addr bigbuf
		jmp	@b
@@:
		invoke	DeleteFile,addr filename
_exit:
		invoke	ExitProcess,0
end start
